<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Teknisa\MAN\Factories;
use Teknisa\MAN\Services\NovoCodigo;
use Teknisa\Libs\Util\Environment;


class CupomDescontoService {
	protected $entityManager;
	protected $util;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Utilities\Util $util)  {
		$this->entityManager = $entityManager;
		$this->util = $util;
	}
	
	public function saveMultiCupons($params){
        return $this->entityManager->getConnection()->executeQuery(self::INSERT_MULTI_CUPONS, $params);
    }
	
	public function saveUnidadeParticipante($params){
        return $this->entityManager->getConnection()->executeQuery(self::INSERT_UNIDADE_PARTICIPANTE, $params);
    }
	
	public function saveProdutosParticipanteIntervalo($params){
        return $this->entityManager->getConnection()->executeQuery(self::INSERT_PRODUTOS_PARTICIPANTE_INTERVALO, $params);
    }
	
	public function saveProdutosParticipanteNivel($params){
        return $this->entityManager->getConnection()->executeQuery(self::INSERT_PRODUTOS_PARTICIPANTE_NIVEL, $params);
    }
	
	public function saveProdutosParticipanteLista($params){
        return $this->entityManager->getConnection()->executeQuery(self::INSERT_PRODUTOS_PARTICIPANTE_LISTA, $params);
    }
    
	public function validRandomCode($code) {
		$params = array(':CODE' => $code);
		$result = $this->entityManager->getConnection()->fetchAll(self::GET_CODE_TO_VALID, $params);
		return (empty($result) ? $code : false);
	}
	
	const GET_CODE_TO_VALID = "
		SELECT CDCUPOMDESCFOS
		  FROM CUPOMDESCFOS
		  WHERE CDCUPOMDESCFOS = :CODE
	";
	
	const INSERT_MULTI_CUPONS = "
		INSERT INTO CUPOMDESCFOS
			(CDCUPOMDESCFOS, DSCUPOMDESCFOS, IDTIPODESC, VRDESCCUPOM, DTINIVIGENCIA, DTFIMVIGENCIA, IDUSOUNICO, NRORG)
			VALUES
			(:CDCUPOMDESCFOS, :DSCUPOMDESCFOS, :IDTIPODESC, :VRDESCCUPOM, :DTINIVIGENCIA, :DTFIMVIGENCIA, :IDUSOUNICO, :NRORG)
	";
	
	const INSERT_UNIDADE_PARTICIPANTE = "
		INSERT INTO FILIALCUPOMDESC
			(CDFILIAL, CDCUPOMDESCFOS, NRORG, DTULTATU, DTINCLUSAO)
			VALUES
			(:CDFILIAL, :CDCUPOMDESCFOS, :NRORG, SYSDATE, SYSDATE)
	";
	
	const INSERT_PRODUTOS_PARTICIPANTE_INTERVALO = "
		INSERT INTO PRODCUPOMDESC
			(CDPRODUTO, CDCUPOMDESCFOS, NRORG, DTULTATU, DTINCLUSAO)
		SELECT CDPRODUTO, :CDCUPOMDESCFOS, :NRORG, SYSDATE, SYSDATE
                FROM PRODUTO 
            WHERE CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF
	";
	
	const INSERT_PRODUTOS_PARTICIPANTE_NIVEL = "
		INSERT INTO PRODCUPOMDESC
			(CDPRODUTO, CDCUPOMDESCFOS, NRORG, DTULTATU, DTINCLUSAO)
		SELECT CDPRODUTO, :CDCUPOMDESCFOS, :NRORG, SYSDATE, SYSDATE
                FROM PRODUTO 
            WHERE CDARVPROD LIKE :PRODNIV||'%'
	";
	
	const INSERT_PRODUTOS_PARTICIPANTE_LISTA = "
		INSERT INTO PRODCUPOMDESC
			(CDPRODUTO, CDCUPOMDESCFOS, NRORG, DTULTATU, DTINCLUSAO)
		SELECT CDPRODUTO, :CDCUPOMDESCFOS, :NRORG, SYSDATE, SYSDATE
                FROM PRODUTO 
            WHERE CDPRODUTO = :CDPRODLIST
	";
}








