<?php

namespace Teknisa\MAN\Services;

use Doctrine\DBAL\Connection;
use Teknisa\MAN\Utilities;

class ParaGeraisProdutoService {
    
    protected $conn;
    
	public function __construct(Connection $conn) {
        $this->conn = $conn;
    }
    
    public function saveProdutos ($CDARVPRODINI, $CDARVPRODFIN, $PRODUTOS, $CDFILIAL, $VRPERCPREPRO, $NRORG) {
        $success = true;
        if(empty($PRODUTOS)){
            $paramsCDPRODUTO = array (
                ':NRORG'           => $NRORG,
                ':CDFILIAL'	       => $CDFILIAL,
    			':CDARVPRODINI'	   => $CDARVPRODINI,
    			':CDARVPRODFIN'	   => $CDARVPRODFIN
            );
            $data = $this->conn->fetchAll(self::FINDPRODUT_INI_FIN, $paramsCDPRODUTO);
            if(empty($data)){
                $success = false;
            }
            
            foreach ($data as $produto => $value) {
                $paramsSave = array (
                  ':CDPRODUTO'      => $value['CDPRODUTO'],
                  ':CDFILIAL'		=> $CDFILIAL,
                  ':NRORG'          => $NRORG,
        		  ':VRPERCPREPRO'   => $VRPERCPREPRO
                );
                
                $this->conn->executeQuery(self::INSERT_PRODPERC, $paramsSave);
            }
        } else {
            foreach ($PRODUTOS as $produto) {
                $paramsSave = array (
                  ':CDPRODUTO'      => $produto,
                  ':CDFILIAL'		=> $CDFILIAL,
                  ':NRORG'          => $NRORG,
          		  ':VRPERCPREPRO'   => $VRPERCPREPRO
                );
                
                $this->conn->executeQuery(self::INSERT_PRODPERC, $paramsSave);
            }
        }
        return $success;
    }
	
    public function updateProduto($NRORG, $CDPRODUTO, $IDPESAPROD, $QTTARAPROD, $CDBARPRODUTO, $NMPRODIMPFIS, $IDCOBTXSERV, $IDTIPOPROD, $CDPROTECLADO, $IDIMPPRODUTO, $IDIMPRODUVEZ, $IDSOLLOCIMP, $DSDADOSFORNVND, $QTDIAVALPRODVND, $DSINFADIPRODVND, $QTPORCAOVND, $IDUNPORCAOVND, $IDPADEMEDCASVND, $IDTIPOMEDCASVND, $QTMEDCASVND, $IDORIGPRODPR) {
		$params = array(
			':NRORG'           => $NRORG,
			':CDPRODUTO'       => $CDPRODUTO,
		    ':IDPESAPROD'      => $IDPESAPROD,
	        ':QTTARAPROD'      => $QTTARAPROD,
	        ':CDBARPRODUTO'    => $CDBARPRODUTO,
	        ':NMPRODIMPFIS'    => $NMPRODIMPFIS,
	        ':IDCOBTXSERV'     => $IDCOBTXSERV,
	        ':IDTIPOPROD'      => $IDTIPOPROD,
	        ':CDPROTECLADO'    => $CDPROTECLADO,
	        ':IDIMPPRODUTO'    => $IDIMPPRODUTO,
	        ':IDIMPRODUVEZ'    => $IDIMPRODUVEZ,
	        ':IDSOLLOCIMP'     => $IDSOLLOCIMP,
	        ':DSDADOSFORNVND'  => $DSDADOSFORNVND,
	        ':QTDIAVALPRODVND' => $QTDIAVALPRODVND,
	        ':DSINFADIPRODVND' => $DSINFADIPRODVND,
	        ':QTPORCAOVND'     => $QTPORCAOVND,
	        ':IDUNPORCAOVND'   => $IDUNPORCAOVND,
	        ':IDPADEMEDCASVND' => $IDPADEMEDCASVND,
	        ':IDTIPOMEDCASVND' => $IDTIPOMEDCASVND,
	        ':QTMEDCASVND'     => $QTMEDCASVND,
	        ':IDORIGPRODPR'    => $IDORIGPRODPR
		);
		return $this->conn->executeQuery(self::UPDATE_PARAGERAIS_PRODUTO, $params);
    }
    
    public function deletePercCalcProduto($CDFILIAL, $NRORG, $CDPRODUTO) {
		$params = array(
		    ':CDFILIAL'        => $CDFILIAL,
			':NRORG'           => $NRORG,
			':CDPRODUTO'       => $CDPRODUTO
		);
		return $this->conn->executeQuery(self::DELETE_PARAGERAIS_PRODUTO_PERCENTUAL, $params);
    }
    
    public function findProdutoField($NRORG, $CDARVPROD){
    	$params = array(
    		':NRORG'		   => $NRORG["value"],
    		':CDARVPROD'	   => $CDARVPROD["value"]
    	);
    	return $this->conn->fetchAll(self::FINDPRODUTO_GERAL, $params);
    	
    }


	const UPDATE_PARAGERAIS_PRODUTO = "
	UPDATE PRODUTO
        SET
          IDPESAPROD      = :IDPESAPROD,
          QTTARAPROD      = :QTTARAPROD,
          CDBARPRODUTO    = :CDBARPRODUTO,
          NMPRODIMPFIS    = :NMPRODIMPFIS,
          IDCOBTXSERV     = :IDCOBTXSERV,
          IDTIPOPROD      = :IDTIPOPROD,
          CDPROTECLADO    = :CDPROTECLADO,
          IDIMPPRODUTO    = :IDIMPPRODUTO,
          IDIMPRODUVEZ    = :IDIMPRODUVEZ,
          IDSOLLOCIMP     = :IDSOLLOCIMP,
          DSDADOSFORNVND  = :DSDADOSFORNVND,
          QTDIAVALPRODVND = :QTDIAVALPRODVND,
          DSINFADIPRODVND = :DSINFADIPRODVND,
          QTPORCAOVND     = :QTPORCAOVND,
          IDUNPORCAOVND   = :IDUNPORCAOVND,
          IDPADEMEDCASVND = :IDPADEMEDCASVND,
          IDTIPOMEDCASVND = :IDTIPOMEDCASVND,
          QTMEDCASVND     = :QTMEDCASVND,
          IDORIGPRODPR    = :IDORIGPRODPR
       WHERE
          CDPRODUTO = :CDPRODUTO AND
          NRORG     = :NRORG
	";
	
	const DELETE_PARAGERAIS_PRODUTO_PERCENTUAL = "
		DELETE FROM PERCACRPROD 
    WHERE CDFILIAL = :CDFILIAL 
  AND NRORG = :NRORG 
  AND CDPRODUTO = :CDPRODUTO
	";
	
	const FINDPRODUT_INI_FIN = "           
    SELECT DISTINCT P.CDPRODUTO
    FROM PRODUTO P 
    WHERE P.NRORG = :NRORG
    AND P.CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFIN
    AND P.CDPRODUTO NOT IN
        (SELECT PERC.CDPRODUTO
         FROM PERCACRPROD PERC
         WHERE PERC.CDFILIAL = :CDFILIAL
           AND PERC.NRORG = :NRORG)";
           
    const INSERT_PRODPERC = "
    INSERT INTO PERCACRPROD
    		(NRORG, CDPRODUTO, CDFILIAL, VRPERCPREPRO)
	VALUES (:NRORG, :CDPRODUTO, :CDFILIAL, :VRPERCPREPRO)
    ";
    
    const FINDPRODUTO_GERAL = "
	SELECT DISTINCT P.NRORG, P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, P.CDARVPROD || ' - ' || P.NMPRODUTO AS PRODUTOSELECAO 
	    FROM PRODUTO P
	    WHERE P.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO) 
	    AND P.NRORG = :NRORG 
        AND (P.CDARVPROD LIKE :CDARVPROD||'%')
	ORDER BY P.CDARVPROD
    ";
}