<?php

namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DependencyInjection\InstanceManager;


class SMTP {

	const GET_SMTP = "
		SELECT DSSMTPAUTVND, DSEMAILAUVND, NRPORTAAUTVND, CDSENHAAUTVNDWEB,
			DSEMAILCLUSO, LOWER(DSSMTPCRIPT) AS DSSMTPCRIPT, IDTPAUTHSMTP
		FROM PARAMGERAL
	";

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
		$this->entityManager = $entityManager;
	}

	public function getSMTP(){
		return $this->entityManager->getConnection()->fetchAll(self::GET_SMTP);
	}

	public function getSMTPFilial($CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL
		);

		return $this->entityManager->getConnection()->fetchAll(self::GET_SMTP_FILIAL, $params);
	}

	const GET_SMTP_FILIAL = "
		SELECT DSEMAILCLUSO
		FROM PARAVEND
		WHERE CDFILIAL = :CDFILIAL
	";     

	public function sendEmail($name_addressee, $email_addressee, $sender, $subject, $content) {
		// Get data from server
        $SMTP = $this->getSMTP();
        $username 	       = $SMTP[0]['DSEMAILAUVND'];
        $server   	       = $SMTP[0]['DSSMTPAUTVND'];
        $password 	       = $SMTP[0]['CDSENHAAUTVNDWEB'];
        $port     	       = $SMTP[0]['NRPORTAAUTVND'];
        $encryption        = $SMTP[0]['DSSMTPCRIPT'];
        $autentication     = $SMTP[0]['IDTPAUTHSMTP'];
        
        
        
		$this->configAndSend($username,$server,$password,$port,$encryption,$autentication,$name_addressee, $email_addressee, $sender, $message);  
    }
    
    public function sendEmailMessage($name_addressee, $email_addressee, $sender, $message) {
        $username 	       = 'retailmanagement@teknisa.com';
        $server   	       = 'smtp.teknisa.com';
        $password 	       = 'Retail@Man1234';
        $port     	       =  25;
        $encryption        = 'sem';
        $autentication     = 'S';
		
		$this->configAndSend($username,$server,$password,$port,$encryption,$autentication,$name_addressee, $email_addressee, $sender, $message);
    	
    }
    
    // The addredd is deprecated.
    private function configAndSend($username,$server,$password,$port,$encryption,$autentication,$name_addressee, $email_addressee, $sender, $message) {
    	$body = utf8_encode($this->generateEmail($subject, $content));
		
		// Using Lib function and configs.
		$smtpMail = InstanceManager::getInstance()->getService('smtpUtil');
        $smtpMail->setSubject($email_addressee);
        $smtpMail->setIsHTML(true);
        $smtpMail->sendMail($body, $email_addressee);
    }
    
    public function generateEmail($subject, $content) {
    	return
    		'<!DOCTYPE html>'.
            '<head>'.
			'<style>
			.TabelaEmail {
				margin:0px;padding:0px;
				width:100%;
				box-shadow: 10px 10px 5px #888888;
				border:1px solid #000000;

				-moz-border-radius-bottomleft:0px;
				-webkit-border-bottom-left-radius:0px;
				border-bottom-left-radius:0px;

				-moz-border-radius-bottomright:0px;
				-webkit-border-bottom-right-radius:0px;
				border-bottom-right-radius:0px;

				-moz-border-radius-topright:0px;
				-webkit-border-top-right-radius:0px;
				border-top-right-radius:0px;

				-moz-border-radius-topleft:0px;
				-webkit-border-top-left-radius:0px;
				border-top-left-radius:0px;
			}.TabelaEmail table{
			    border-collapse: collapse;
			        border-spacing: 0;
				width:100%;
				height:100%;
				margin:0px;padding:0px;
			}.TabelaEmail tr:last-child td:last-child {
				-moz-border-radius-bottomright:0px;
				-webkit-border-bottom-right-radius:0px;
				border-bottom-right-radius:0px;
			}
			.TabelaEmail table tr:first-child td:first-child {
				-moz-border-radius-topleft:0px;
				-webkit-border-top-left-radius:0px;
				border-top-left-radius:0px;
			}
			.TabelaEmail table tr:first-child td:last-child {
				-moz-border-radius-topright:0px;
				-webkit-border-top-right-radius:0px;
				border-top-right-radius:0px;
			}.TabelaEmail tr:last-child td:first-child{
				-moz-border-radius-bottomleft:0px;
				-webkit-border-bottom-left-radius:0px;
				border-bottom-left-radius:0px;
			}.TabelaEmail tr:hover td{
				background-color:#fcddbf;
			}
			.TabelaEmail td{
				vertical-align:middle;
					background:-o-linear-gradient(bottom, #f4c395 5%, #fcddbf 100%);	background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #f4c395), color-stop(1, #fcddbf) );
				background:-moz-linear-gradient( center top, #f4c395 5%, #fcddbf 100% );
				filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#f4c395", endColorstr="#fcddbf");	background: -o-linear-gradient(top,#f4c395,fcddbf);

				background-color:#f4c395;

				height: 40px;
				border:1px solid #000000;
				border-width:0px 1px 1px 0px;
				text-align:left;
				padding:7px;
				font-size:10px;
				font-family:Arial;
				font-weight:normal;
				color:#000000;
			}.TabelaEmail tr:last-child td{
				border-width:0px 1px 0px 0px;
			}.TabelaEmail tr td:last-child{
				border-width:0px 0px 1px 0px;
			}.TabelaEmail tr:last-child td:last-child{
				border-width:0px 0px 0px 0px;
			}
			.TabelaEmail tr:first-child td{
					background:-o-linear-gradient(bottom, #E95F28 5%, #E95F28 100%);	background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #E95F28), color-stop(1, #E95F28) );
				background:-moz-linear-gradient( center top, #E95F28 5%, #E95F28 100% );
				filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#E95F28", endColorstr="#E95F28");	background: -o-linear-gradient(top,#E95F28,E95F28);

				background-color:#E95F28;
				border:0px solid #000000;
				text-align:center;
				border-width:0px 0px 1px 1px;
				font-size:15px;
				font-family:Arial;
				font-weight:bold;
				color:#ffffff;
			}
			.TabelaEmail tr:first-child:hover td{
				background:-o-linear-gradient(bottom, #E95F28 5%, #bf5f00 100%);	background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #E95F28), color-stop(1, #bf5f00) );
				background:-moz-linear-gradient( center top, #E95F28 5%, #bf5f00 100% );
				filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#E95F28", endColorstr="#bf5f00");	background: -o-linear-gradient(top,#E95F28,bf5f00);

				background-color:#E95F28;
			}
			.TabelaEmail tr:first-child td:first-child{
				border-width:0px 0px 1px 0px;
			}
			.TabelaEmail tr:first-child td:last-child{
				border-width:0px 0px 1px 1px;
			}
			</style>'.
			'<meta http-equiv="content-type" content="text/html; charset=UTF-8">'.
			'</head>'.
			'<body>'.
			'<center>'.
			'<div class="TabelaEmail" style="width: 500; height: 300">'.
			'<table>'.
			'<tr>'.
			'<td valign="top" align="center">'.
			'<strong>'.
			'<font face="Arial" size="4"> '.$subject.' </font>'.
			'</strong>'.
			'</td>'.
			'</tr>'.
			'<tr>'.
			'<td>'.
			'<font face="Arial" size="2"> '.$content.' </font>'.
			'<center><img src="https://manage.teknisa.com/assets/images/logo.png" style="width: 250px;"></center>'.
			'</td>'.
			'</tr>'.
			'</table>'.
			'</div>'.
			'</center>'.
			'</body>'.
			'</html>'
		;
	}

}